Summary: MIPS32 simulator
Name: spim
Version: 7.2.1
Release: 1.%deployment_release_suffix.1
License: Free for non-commercial use
Group: Applications/Emulators
URL: http://www.cs.wisc.edu/~larus/spim.html
Source0: http://www.cs.wisc.edu/~larus/SPIM/%{name}-%{version}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: xorg-x11-proto-devel
BuildRequires: binutils
BuildRequires: flex
BuildRequires: tetex-dvips
BuildRequires: tetex-latex
%{?sampler_tags}
Source1: xev.c
Patch0: xspim-event-dispatch.patch

%description 
SPIM is a self-contained simulator that will run MIPS32 assembly
language programs.  It reads and immediately executes assembly
language code for this processor.  SPIM provides a simple debugger and
minimal set of operating system services.

%{?sampler_description}

%prep
%setup -q
%patch0

%build
%{!?deployment_scheme_flags: %define deployment_scheme_flags --sampler-scheme=branches --sampler-scheme=returns}
%define sampler_cc_flags --exclude-file=lex.yy.c --exclude-file=y.tab.c %deployment_scheme_flags
%sampler_prebuild
ln -s ../Documentation/xspim.man xspim
ln -s %{S:1} xspim
make CC="$CC" EXCEPTION_PATH=%_datadir/%name/exceptions.s XOBJS='xev.o $(BASE_OBJS) $(BASE_XOBJS)' -C xspim
make CC="$CC" EXCEPTION_PATH='\"%_datadir/%name/exceptions.s\"' -C spim

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}
%sampler_prebuild
ln -s ../CPU/exceptions.s spim
ln -s ../Documentation/spim.man spim
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man1
make CC="$CC" BIN_DIR=$RPM_BUILD_ROOT%_bindir MAN_DIR=$RPM_BUILD_ROOT%_mandir/man1 EXCEPTION_PATH=$RPM_BUILD_ROOT%_datadir/%name/exceptions.s XOBJS='xev.o $(BASE_OBJS) $(BASE_XOBJS)' -C xspim install install.man
make CC="$CC" BIN_DIR=$RPM_BUILD_ROOT%_bindir MAN_DIR=$RPM_BUILD_ROOT%_mandir/man1  EXCEPTION_DIR=$RPM_BUILD_ROOT%_datadir/%name -C spim  install
install spim/spim $RPM_BUILD_ROOT%{_bindir}/spim
mv $RPM_BUILD_ROOT%{_mandir}/man1/spim.man $RPM_BUILD_ROOT%{_mandir}/man1/spim.1
%sampler_install %_bindir/spim %_bindir/xspim

%clean
rm -rf $RPM_BUILD_ROOT

%post
%{?sampler_post}

%files
%defattr(-,root,root,-)
%doc %{_mandir}/*/*
%doc ChangeLog
%doc Documentation/BLURB
%doc Documentation/SPIM.html
%doc Documentation/TeX/spim.ps
%doc README
%doc Tests
%{_bindir}/*
%{_datadir}/%{name}
%{?sampler_files}
%{?sampler_files_gconf}

%{?sampler_package}

%changelog
* Mon Aug 29 2005 Ben Liblit <liblit@cs.wisc.edu> - 7.2.1-1.%{deployment_release_suffix}.1
- Updated for release 7.2.1.

* Tue Aug  2 2005 Ben Liblit <liblit@cs.wisc.edu> - 7.1-1.%{deployment_release_suffix}.4
- Rebuild with sampler-1.2.1.

* Tue May  3 2005 Ben Liblit <liblit@cs.berkeley.edu> - 7.1-1.%{deployment_release_suffix}.3
- Merge Stanford and standard deployment branches.

* Wed Mar 23 2005 Ben Liblit <liblit@cs.berkeley.edu> - 7.1.stan.2
- Configuration tweaks for Stanford CBI study.

* Mon Mar 21 2005 Ben Liblit <liblit@cs.wisc.edu> - 7.1.sam.2
- Rebuild with sampler-1.1 and new feedback reporting URL.

* Mon Jan 17 2005 Ben Liblit <liblit@cs.berkeley.edu> - 7.1-1
- Updated for release 7.1.
- Added hooks for sampled instrumentation.

* Sat Aug 28 2004 Ben Liblit <liblit@cs.berkeley.edu> 7.0-1
- Initial build.
